<template>
  <div class="pt-4">
    <v-row
      justify="center"
    >
      <v-card
        max-width="700px"
      >
        <v-tabs
          v-model="tab"
          background-color="primary"
          centered
          dark
          icons-and-text
        >
          <v-tabs-slider></v-tabs-slider>

          <v-tab class="" href="#tab-1">
            SignIn
             <v-icon color="">mdi-face</v-icon>
          </v-tab>
        </v-tabs>
        <v-tabs-items v-model="tab">
          <v-tab-item
          value="tab-1"
          >
            <Signin
              v-on:submit="submit"
            >
            </Signin>
          </v-tab-item>
        </v-tabs-items>
      </v-card>
    </v-row>
    <!-- <Signin
      v-on:submit="submit"
    >
    </Signin> -->
  </div>
</template>

<script>

import Signin from '@/components/login/Signin.vue';
import { mapGetters } from 'vuex';
import * as firebase from 'firebase';
// eslint-disable-next-line import/no-cycle
import { getProfile, setProfile, sendEmailVerification } from '@/firebase/db';

export default {
  components: {
    Signin,
  },
  data() {
    return {
      tab: null,
    };
  },
  computed: {
    ...mapGetters({
      user: 'getUser',
      accountcreated: 'getAccountCreated',
    }),
  },
  created() {
  },
  watch: {
  },
  methods: {
    setUserProfile(user) {
      const userProfile = {
        displayName: user.displayName,
        photoUrl: user.photoURL,
        email: user.email,
        emailVerified: user.emailVerified,
        phoneNumber: user.phoneNumber,
        providerId: user.providerData ? user.providerData[0].providerId : null,
        authToken: {
          ...user.stsTokenManager,
        },
      };
      setProfile(userProfile);
      this.$store.dispatch('setUserProfile', userProfile);
    },
    submit(email, password) {
      this.$store.dispatch('setOverlay', true);
      firebase.auth().signInWithEmailAndPassword(email, password)
        .then((user1) => {
          console.log('signInSuccessWithAuthResult: *************************');
          console.log('auth result', user1);
          // console.log('auth result', user1.additionalUserInfo);
          const { user, credential, operationType } = user1;
          const { isNewUser, providerId } = user1.additionalUserInfo;
          console.log(`isNewUser: ${isNewUser}, user: ${JSON.stringify(user, null, 2)})`);
          console.log(typeof user);
          console.log(`credentianl: ${JSON.stringify(credential, null, 2)}, operationType: ${operationType}, providerId: ${providerId}`);
          this.$store.dispatch('setUser', user);
          if (isNewUser) {
            this.setUserProfile(user);
          } else {
            getProfile().then((profile) => {
              sendEmailVerification();
              if (profile.email) {
                this.$store.dispatch('setUserProfile', profile);
              } else {
                console.log('Got no userProfile');
                console.log(JSON.stringify(user.stsTokenManager, null, 2));
                this.setUserProfile(user);
              }
            });
          }
          const redirectToUrl = this.$store.getters.getRedirectToUrl;
          if (redirectToUrl) {
            console.log(`signInSuccess: redirectToUrl is ${redirectToUrl}`);
            this.$store.dispatch('setRedirectToUrl', null);
            this.$router.replace({ name: redirectToUrl });
          } else {
            console.log('signInSuccess: navigating to home');
            this.$router.replace({ name: 'home' });
          }
          this.$store.dispatch('setUserid', user.email);
          this.$store.dispatch('setSnackbarText', 'Login Successfully');
          this.$store.dispatch('setShowSnackbar', true);
          this.$store.dispatch('setOverlay', false);
          setTimeout(() => {
            this.$store.dispatch('setShowSnackbar', false);
          }, 4000);
        }).catch((error) => {
          this.$store.dispatch('setSnackbarText', error.message);
          this.$store.dispatch('setShowSnackbar', true);
          this.$store.dispatch('setOverlay', false);
          setTimeout(() => {
            this.$store.dispatch('setShowSnackbar', false);
          }, 4000);
        });
    },
  },
};
</script>
